;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;               PROOF CHECKER FOR DURATION CALCULUS IN PVS
;;; File: dc.lisp
;;; Date: Tue Sep 29 1998
;;; Original version for PVS1 by:
;;;   Jens Ulrik Skakkebaek and Sam Owre
;;; Adapted for PVS2 by:
;;;   Soeren T. Heilmann, sh@it.dtu.dk
;;;   Dept. of Information Technology, Technical University of Denmark
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;
;;; NB! Remember to load opers.lisp and sorts.lisp when recompiling for Allegro
;;; 

(in-package 'pvs)

; The chop character is ; when the DC parser is loaded else ^
(defvar *dc-chop-char* #\^)

(defvar *dc-directory* nil)

(eval-when (eval compile load)
  (setq *dc-directory* (format nil "~a/dc" (environment-variable "PVSPATH")))
  (pushnew "dc/src/" *pvs-directories*
	   :test #'string=))


(defun dc-load (file)
  (load (format nil "~a/src/~a" *dc-directory* file)))

(defun load-dc ()
  (setf *dc-chop-char* #\^)

  (dc-load "dc-utils")
  (dc-load "dc-strategies")
  (dc-load "dc-bdd")

  (pvs-message "PC/DC ready")
  )


