(***************************************************************************
 File "checking.sml" Updated 1993-02-10
 Duration Calculus checker, version 2
 Main file
 Sestoft and Skakkebaek, Computer Science, Technical University of Denmark
***************************************************************************)

use "basic.sml";
use "natsetset.sml";
use "natfun.sml";
use "printer.sml";
use "bdd.sml";
use "autoprint.sml";
use "formula.sml";
use "partition.sml";
use "nfa.sml";
use "valid.sml";

structure Bdd = 
    Bdd      (structure Basic = Basic)
structure Formula = 
    Formula  (structure Basic = Basic)
structure Partition = 
    Partition(structure Basic = Basic
	      and Natsetset = Natsetset
	      and Natfun = Natfun
	      and Bdd = Bdd)
structure Nfa = 
    Nfa      (structure Basic = Basic
	      and Natsetset = Natsetset
	      and Natfun = Natfun
	      and Bdd = Bdd
	      and Formula = Formula
	      and Partition = Partition)
structure Autoprint = 
    Autoprint(structure Prt = Prt
	      and Basic = Basic
	      and Natsetset = Natsetset
	      and Natfun = Natfun
	      and Bdd = Bdd)
structure Valid = 
    Valid    (structure Basic = Basic 
	      and Formula = Formula
	      and Natsetset = Natsetset
	      and Nfa = Nfa
	      and Autoprint = Autoprint)

open Valid
