(***************************************************************************
 File "fischer.sml" Updated 1993-02-10
 Duration Calculus checker, version 2
 ? Simple Fischer, direct encoding (not TTD). JUS december 1992
 Sestoft and Skakkebaek, Computer Science, Technical University of Denmark
***************************************************************************)

(*** Time ***)

val len_eq_1 = "('tt' & (~('tt';'tt')))"

val len_gt_0 = "'tt'"
val len_gt_1 = "("^len_eq_1^";'tt')"
val len_gt_2 = "("^len_eq_1^";"^len_eq_1^";'tt')"
val len_gt_3 = "("^len_eq_1^";"^len_eq_1^";"^len_eq_1^";'tt')"
val len_gt_4 = "("^len_eq_1^";"^len_eq_1^";"^len_eq_1^";"^len_eq_1^";'tt')"
val len_gt_5 = "("^len_eq_1^";"^len_eq_1^";"^len_eq_1^";"^len_eq_1^";"^len_eq_1^";'tt')"

val len_leq_1 = "(~("^len_gt_1^"))"
val len_leq_2 = "(~("^len_gt_2^"))"
val len_leq_3 = "(~("^len_gt_3^"))"
val len_leq_4 = "(~("^len_gt_4^"))"


(*** Process #1  ***)
(*
valid ("(('tt';'tt') =>(("^init^"&"^aut1^") & (('a1';'cs1'))))");
valid ("~(('tt';'tt') => 'a1')");
valid ("('a1';true) & '~a1'");
*)

val ser1 = "(([](('a1';true) => ('a1' | ('a1';'b1';true)))) & ([](('b1';true) => ('b1' | ('b1';'c1';true)))) & ([](('c1';true) => ('c1' | ('c1';'cs1';true)))) & ([](('cs1';true) => 'cs1')))"

val ser1' = "(([](('a1';true) => ('a1' | ('a1';'b1';true)))) & ([](('b1';true) => ('b1' | ('b1';'c1';true)))) & ([](('c1';true) => ('c1' | ('c1';'cs1';true)))) & ([](('cs1';true) => 'cs1'))  & (('a2'|(~'a2')) & ('b2'|(~'b2')) & ('c2'|(~'c2'))))"

val ser1'' = "(([](('a1';true) => ('a1' | ('a1';'b1';true)))) & ([](('b1';true) => ('b1' | ('b1';'c1';true)))) & ([](('c1';true) => ('c1' | ('c1';'cs1';true)))) & ([](('cs1';true) => 'cs1'))  & ('tt' => (('a2'|(~'a2')))))"
    
val ser1''' = "(([](('a1';true) => ('a1' | ('a1';'b1';true)))) & ([](('b1';true) => ('b1' | ('b1';'c1';true)))) & ([](('c1';true) => ('c1' | ('c1';'cs1';true)))) & ([](('cs1';true) => 'cs1'))  & ('tt' => (('a2'|(~'a2')) & ('b2'|(~'b2')))))"

val excl1 = "(([]('a1'=>(~('b1'|'c1'|'cs1')))) & ([]('b1'=>(~('a1'|'c1'|'cs1')))) & ([]('c1'=>(~('a1'|'b1'|'cs1')))) & ([]('cs1'=>(~('a1'|'b1'|'c1')))) & ([]('tt'=>'a1|b1|c1|cs1')))"

val excl1' = "([]('tt'=>('(a1&(~b1)&(~c1)&(~cs1))|((~a1)&b1&(~c1)&(~cs1))|((~a1)&(~b1)&c1&(~cs1))|((~a1)&(~b1)&(~c1)&cs1)')))"

val aut1 = "("^ser1^" & "^excl1'^")"

val trans1 = "(([](('a1';'b1') => (true;'a1&xeq0';'b1'))) & ([](('b1';'c1') => ('b1';'c1&xeq1';true))) & ([](('c1';'cs1') => (true;'c1&xeq1';'cs1'))))"

val time1 = "(([]('b1' => "^len_leq_2^")) & ([](('~c1';'c1';'~c1') => "^len_gt_4^")))"

val time1' = "true"

val process1 = "("^aut1^" & "^trans1^" & "^time1^")"


(*** Process #2  ***)

val ser2 = "(([](('a2';true) => ('a2' | ('a2';'b2';true)))) & ([](('b2';true) => ('b2' | ('b2';'c2';true)))) & ([](('c2';true) => ('c2' | ('c2';'cs2';true)))) & ([](('cs2';true) => 'cs2')))"

val excl2 = "(([]('a2'=>(~('b2'|'c2'|'cs2')))) & ([]('b2'=>(~('a2'|'c2'|'cs2')))) & ([]('c2'=>(~('a2'|'b2'|'cs2')))) & ([]('cs2'=>(~('a2'|'b2'|'c2')))) & ([]('tt'=>'a2|b2|c2|cs2')))"

val excl2' = "([]('tt'=>('(a2&(~b2)&(~c2)&(~cs2))|((~a2)&b2&(~c2)&(~cs2))|((~a2)&(~b2)&c2&(~cs2))|((~a2)&(~b2)&(~c2)&cs2)')))"


val aut2 = "("^ser2^" & "^excl2'^")"

val trans2 = "(([](('a2';'b2') => (true;'a2&xeq0';'b2'))) & ([](('b2';'c2') => ('b2';'c2&xeq2';true))) & ([](('c2';'cs2') => (true;'c2&xeq2';'cs2'))))"

val time2 = "(([]('b2' => "^len_leq_2^")) & ([](('~c2';'c2';'~c2') => "^len_gt_4^")))"

val time2' = "true"

val process2 = "("^aut2^" & "^trans2^" & "^time2^")"


(*** System Spec ***)

val init = "(('a1';true) & ('a2';true) & ('xeq0';true))"

val exclX = "(([]('xeq0'=>(~('xeq1'|'xeq2')))) & ([]('xeq1'=>(~('xeq0'|'xeq2')))) & ([]('xeq2'=>(~('xeq0'|'xeq1')))) & ([]('tt'=>'xeq0|xeq1|xeq2')))"

val exclX' = "([]('tt'=>('(xeq0&(~xeq1)&(~xeq2))|((~xeq0)&xeq1&(~xeq2))|((~xeq0)&(~xeq1)&xeq2)')))"

val X = "(([]((('xeq1';true) & (~(<>('~c2';'c2')))) => 'xeq1')) & ([]((('xeq2';true) & (~(<>('~c1';'c1')))) => 'xeq2')))"

val system = "("^init^" & "^exclX'^" & "^X^" & "^process1^" & "^process2^")"

val system' = "("^init^" & "^exclX^" & "^X^" & "^process1^" & "^process2^")" 

(*
  timeit valid1 (init^" & "^exclX^" & "^process1);
*)

(*** Requirement Spec ***)

val mutex = "(~(<>('cs1'&'cs2')))"

val mutex' = "([](~'cs1&cs2'))"

(*** Proof ***)

val fischer = "("^system^" => "^mutex^")"

val fischer' = "("^system'^" => "^mutex^")"

val prop = "("^process1^" => "^time1^")"
val prop1 = "("^time1^"&"^excl1^" => "^time1^")"
val prop2 = "("^aut1^"&"^excl1^" => "^time1^")"
val prop3 = len_gt_2^" => ('tt';'tt')"

