(* File "ffischer.sml" PS version *)

(*** Time ***)

val len_eq_1 = "('tt' & (~('tt';'tt')))"

val len_gt_0 = "'tt'"
val len_gt_1 = "("^len_eq_1^";'tt')"
val len_gt_2 = "("^len_eq_1^";"^len_eq_1^";'tt')"
val len_gt_3 = "("^len_eq_1^";"^len_eq_1^";"^len_eq_1^";'tt')"
val len_gt_4 = "("^len_eq_1^";"^len_eq_1^";"^len_eq_1^";"^len_eq_1^";'tt')"
val len_gt_5 = "("^len_eq_1^";"^len_eq_1^";"^len_eq_1^";"^len_eq_1^";"^len_eq_1^";'tt')"

val len_leq_1 = "(~("^len_gt_1^"))"
val len_leq_2 = "(~("^len_gt_2^"))"
val len_leq_3 = "(~("^len_gt_3^"))"
val len_leq_4 = "(~("^len_gt_4^"))"


(*** Process #1  ***)

val ser1 = "(([](('a1';true) => ('a1' | ('a1';'b1';true)))) & ([](('b1';true) => ('b1' | ('b1';'c1';true)))) & ([](('c1';true) => ('c1' | ('c1';'cs1|a1';true)))) & ([](('cs1';true) => ('cs1' | ('cs1';'a1';true)))))"

val excl1 = "([]('tt'=>('(a1&(~b1)&(~c1)&(~cs1))|((~a1)&b1&(~c1)&(~cs1))|((~a1)&(~b1)&c1&(~cs1))|((~a1)&(~b1)&(~c1)&cs1)')))"

val aut1 = "("^ser1^" & "^excl1^")"

val trans1 = "(([](('a1';'b1') => (true;'a1&xeq0';'b1'))) & ([](('b1';'c1') => ('b1';'c1&xeq1';true))) & ([](('c1';'cs1') => (true;'c1&xeq1';'cs1'))) & ([](('cs1';'a1') => ('cs1';'a1&xeq0';true))) & ([](('c1';'a1') => (true;'c1&(~xeq1)';'a1'))))"

val time1 = "(([]('b1' => "^len_leq_2^")) & ([](('~c1';'c1';'~c1') => "^len_gt_4^")))"

val process1 = "("^aut1^" & "^trans1^" & "^time1^")"

(*** Process #2  ***)
val ser2 = "(([](('a2';true) => ('a2' | ('a2';'b2';true)))) & ([](('b2';true) => ('b2' | ('b2';'c2';true)))) & ([](('c2';true) => ('c2' | ('c2';'cs2|a2';true)))) & ([](('cs2';true) => ('cs2' | ('cs2';'a2';true)))))"

val excl2 = "([]('tt'=>('(a2&(~b2)&(~c2)&(~cs2))|((~a2)&b2&(~c2)&(~cs2))|((~a2)&(~b2)&c2&(~cs2))|((~a2)&(~b2)&(~c2)&cs2)')))"

val aut2 = "("^ser2^" & "^excl2^")"

val trans2 = "(([](('a2';'b2') => (true;'a2&xeq0';'b2'))) & ([](('b2';'c2') => ('b2';'c2&xeq2';true))) & ([](('c2';'cs2') => (true;'c2&xeq2';'cs2'))) & ([](('cs2';'a2') => ('cs2';'a2&xeq0';true))) & ([](('c2';'a2') => (true;'c2&(~xeq2)';'a2'))))"

val time2 = "(([]('b2' => "^len_leq_2^")) & ([](('~c2';'c2';'~c2') => "^len_gt_4^")))"

val process2 = "("^aut2^" & "^trans2^" & "^time2^")"

(*** System Spec ***)

val init = "(('a1';true) & ('a2';true) & ('xeq0';true))"

val exclX = "([]('tt'=>('(xeq0&(~xeq1)&(~xeq2))|((~xeq0)&xeq1&(~xeq2))|((~xeq0)&(~xeq1)&xeq2)')))"

(*val X = "(([]((('xeq1';true) & (~(<>(('~c2';'c2')|('~a1';'a1')|('~a2';'a2'))))) => 'xeq1')) & ([]((('xeq2';true) & (~(<>(('~c1';'c1')|('~a1';'a1')|('~a2';'a2'))))) => 'xeq2')) & ([]((('xeq0';true) & (~(<>(('~c1';'c1')|('~c2';'c2'))))) => 'xeq0')))"*)

val X = "(([]((('xeq1';true) & (~(<>(('~c2';'c2')|('cs1';'a1'))))) => 'xeq1')) & ([]((('xeq2';true) & (~(<>(('~c1';'c1')|('cs2';'a2'))))) => 'xeq2')) & ([]((('xeq0';true) & (~(<>(('~c1';'c1')|('~c2';'c2'))))) => 'xeq0')))"

val system = "("^init^" & "^exclX^" & "^X^" & "^process1^" & "^process2^")"

(*** Requirement Spec ***)

val mutex = "(~(<>('cs1'&'cs2')))"

(*** Proof ***)

val fischer = "("^system^" => "^mutex^")"
